diff --git a/arch/arm/kernel/setup.c b/arch/arm/kernel/setup.c
index 75cd4699e7b3..7f3dc9ff32f7 100644
--- a/arch/arm/kernel/setup.c
+++ b/arch/arm/kernel/setup.c
@@ -1016,8 +1016,8 @@ static void __init reserve_crashkernel(void)
 	int ret;
 
 	total_mem = get_total_mem();
-	ret = parse_crashkernel(boot_command_line, total_mem,
-				&crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line, total_mem,
+				       &crash_size, &crash_base);
 	/* invalid value specified or crashkernel=0 */
 	if (ret || !crash_size)
 		return;
diff --git a/arch/arm64/mm/init.c b/arch/arm64/mm/init.c
index c28c2c8483cc..2fc4ea0b5b7a 100644
--- a/arch/arm64/mm/init.c
+++ b/arch/arm64/mm/init.c
@@ -114,8 +114,8 @@ static void __init reserve_crashkernel(void)
 		return;
 
 	/* crashkernel=X[@offset] */
-	ret = parse_crashkernel(cmdline, memblock_phys_mem_size(),
-				&crash_size, &crash_base);
+	ret = parse_crashkernel_common(cmdline, memblock_phys_mem_size(),
+				       &crash_size, &crash_base);
 	if (ret == -ENOENT) {
 		ret = parse_crashkernel_high(cmdline, 0, &crash_size, &crash_base);
 		if (ret || !crash_size)
diff --git a/arch/ia64/kernel/setup.c b/arch/ia64/kernel/setup.c
index c05728044272..91531fce0ba3 100644
--- a/arch/ia64/kernel/setup.c
+++ b/arch/ia64/kernel/setup.c
@@ -276,8 +276,8 @@ static void __init setup_crashkernel(unsigned long total, int *n)
 	unsigned long long base = 0, size = 0;
 	int ret;
 
-	ret = parse_crashkernel(boot_command_line, total,
-			&size, &base);
+	ret = parse_crashkernel_common(boot_command_line, total,
+				       &size, &base);
 	if (ret == 0 && size > 0) {
 		if (!base) {
 			sort_regions(rsvd_region, *n);
diff --git a/arch/loongarch/kernel/setup.c b/arch/loongarch/kernel/setup.c
index 4444b13418f0..17f9d3d58906 100644
--- a/arch/loongarch/kernel/setup.c
+++ b/arch/loongarch/kernel/setup.c
@@ -267,7 +267,8 @@ static void __init arch_parse_crashkernel(void)
 	unsigned long long crash_base, crash_size;
 
 	total_mem = memblock_phys_mem_size();
-	ret = parse_crashkernel(boot_command_line, total_mem, &crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line, total_mem,
+				       &crash_size, &crash_base);
 	if (ret < 0 || crash_size <= 0)
 		return;
 
diff --git a/arch/mips/cavium-octeon/setup.c b/arch/mips/cavium-octeon/setup.c
index c5561016f577..bdcac8a4d85e 100644
--- a/arch/mips/cavium-octeon/setup.c
+++ b/arch/mips/cavium-octeon/setup.c
@@ -885,7 +885,7 @@ void __init prom_init(void)
 			strcat(arcs_cmdline, arg);
 			/*
 			 * To do: switch parsing to new style, something like:
-			 * parse_crashkernel(arg, sysinfo->system_dram_size,
+			 * parse_crashkernel_common(arg, sysinfo->system_dram_size,
 			 *		  &crashk_size, &crashk_base);
 			 */
 #endif
diff --git a/arch/mips/kernel/setup.c b/arch/mips/kernel/setup.c
index c0e65135481b..99f3ed8aeb35 100644
--- a/arch/mips/kernel/setup.c
+++ b/arch/mips/kernel/setup.c
@@ -457,8 +457,8 @@ static void __init mips_parse_crashkernel(void)
 	int ret;
 
 	total_mem = memblock_phys_mem_size();
-	ret = parse_crashkernel(boot_command_line, total_mem,
-				&crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line, total_mem,
+				       &crash_size, &crash_base);
 	if (ret != 0 || crash_size <= 0)
 		return;
 
diff --git a/arch/powerpc/kernel/fadump.c b/arch/powerpc/kernel/fadump.c
index ea0a073abd96..b4a038cbd1cf 100644
--- a/arch/powerpc/kernel/fadump.c
+++ b/arch/powerpc/kernel/fadump.c
@@ -312,8 +312,9 @@ static __init u64 fadump_calculate_reserve_size(void)
 	 * option. If yes, then use that but ignore base as fadump reserves
 	 * memory at a predefined offset.
 	 */
-	ret = parse_crashkernel(boot_command_line, memblock_phys_mem_size(),
-				&size, &base);
+	ret = parse_crashkernel_common(boot_command_line,
+				       memblock_phys_mem_size(),
+				       &size, &base);
 	if (ret == 0 && size > 0) {
 		unsigned long max_size;
 
diff --git a/arch/powerpc/kexec/core.c b/arch/powerpc/kexec/core.c
index de64c7962991..853de54cc2db 100644
--- a/arch/powerpc/kexec/core.c
+++ b/arch/powerpc/kexec/core.c
@@ -108,8 +108,8 @@ void __init reserve_crashkernel(void)
 
 	total_mem_sz = memory_limit ? memory_limit : memblock_phys_mem_size();
 	/* use common parsing */
-	ret = parse_crashkernel(boot_command_line, total_mem_sz,
-			&crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line, total_mem_sz,
+				       &crash_size, &crash_base);
 	if (ret == 0 && crash_size > 0) {
 		crashk_res.start = crash_base;
 		crashk_res.end = crash_base + crash_size - 1;
diff --git a/arch/powerpc/mm/nohash/kaslr_booke.c b/arch/powerpc/mm/nohash/kaslr_booke.c
index 2fb3edafe9ab..8c049659056f 100644
--- a/arch/powerpc/mm/nohash/kaslr_booke.c
+++ b/arch/powerpc/mm/nohash/kaslr_booke.c
@@ -177,8 +177,8 @@ static void __init get_crash_kernel(void *fdt, unsigned long size)
 	unsigned long long crash_size, crash_base;
 	int ret;
 
-	ret = parse_crashkernel(boot_command_line, size, &crash_size,
-				&crash_base);
+	ret = parse_crashkernel_common(boot_command_line, size,
+				       &crash_size, &crash_base);
 	if (ret != 0 || crash_size == 0)
 		return;
 	if (crash_base == 0)
diff --git a/arch/riscv/mm/init.c b/arch/riscv/mm/init.c
index 4fa420faa780..6d4b27fc254b 100644
--- a/arch/riscv/mm/init.c
+++ b/arch/riscv/mm/init.c
@@ -1326,8 +1326,9 @@ static void __init reserve_crashkernel(void)
 		return;
 	}
 
-	ret = parse_crashkernel(boot_command_line, memblock_phys_mem_size(),
-				&crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line,
+				       memblock_phys_mem_size(),
+				       &crash_size, &crash_base);
 	if (ret || !crash_size)
 		return;
 
diff --git a/arch/s390/kernel/setup.c b/arch/s390/kernel/setup.c
index fe10da1a271e..9693f155936e 100644
--- a/arch/s390/kernel/setup.c
+++ b/arch/s390/kernel/setup.c
@@ -625,8 +625,8 @@ static void __init reserve_crashkernel(void)
 	phys_addr_t low, high;
 	int rc;
 
-	rc = parse_crashkernel(boot_command_line, ident_map_size, &crash_size,
-			       &crash_base);
+	rc = parse_crashkernel_common(boot_command_line, ident_map_size,
+				      &crash_size, &crash_base);
 
 	crash_base = ALIGN(crash_base, KEXEC_CRASH_MEM_ALIGN);
 	crash_size = ALIGN(crash_size, KEXEC_CRASH_MEM_ALIGN);
diff --git a/arch/sh/kernel/machine_kexec.c b/arch/sh/kernel/machine_kexec.c
index 223c14f44af7..9775f6fe245c 100644
--- a/arch/sh/kernel/machine_kexec.c
+++ b/arch/sh/kernel/machine_kexec.c
@@ -153,8 +153,9 @@ void __init reserve_crashkernel(void)
 	unsigned long long crash_size, crash_base;
 	int ret;
 
-	ret = parse_crashkernel(boot_command_line, memblock_phys_mem_size(),
-			&crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line,
+				       memblock_phys_mem_size(),
+				       &crash_size, &crash_base);
 	if (ret == 0 && crash_size > 0) {
 		crashk_res.start = crash_base;
 		crashk_res.end = crash_base + crash_size - 1;
diff --git a/arch/x86/kernel/setup.c b/arch/x86/kernel/setup.c
index 16babff771bd..b2b67b8c1c1e 100644
--- a/arch/x86/kernel/setup.c
+++ b/arch/x86/kernel/setup.c
@@ -558,7 +558,8 @@ static void __init reserve_crashkernel(void)
 	total_mem = memblock_phys_mem_size();
 
 	/* crashkernel=XM */
-	ret = parse_crashkernel(boot_command_line, total_mem, &crash_size, &crash_base);
+	ret = parse_crashkernel_common(boot_command_line, total_mem,
+				       &crash_size, &crash_base);
 	if (ret != 0 || crash_size <= 0) {
 		/* crashkernel=X,high */
 		ret = parse_crashkernel_high(boot_command_line, total_mem,
diff --git a/include/linux/crash_core.h b/include/linux/crash_core.h
index de62a722431e..6ec10ed5c6a6 100644
--- a/include/linux/crash_core.h
+++ b/include/linux/crash_core.h
@@ -77,7 +77,7 @@ Elf_Word *append_elf_note(Elf_Word *buf, char *name, unsigned int type,
 			  void *data, size_t data_len);
 void final_note(Elf_Word *buf);
 
-int __init parse_crashkernel(char *cmdline, unsigned long long system_ram,
+int __init parse_crashkernel_common(char *cmdline, unsigned long long system_ram,
 		unsigned long long *crash_size, unsigned long long *crash_base);
 int parse_crashkernel_high(char *cmdline, unsigned long long system_ram,
 		unsigned long long *crash_size, unsigned long long *crash_base);
diff --git a/kernel/crash_core.c b/kernel/crash_core.c
index 90ce1dfd591c..57738ca0ee7f 100644
--- a/kernel/crash_core.c
+++ b/kernel/crash_core.c
@@ -273,17 +273,13 @@ static int __init __parse_crashkernel(char *cmdline,
 	return parse_crashkernel_simple(ck_cmdline, crash_size, crash_base);
 }
 
-/*
- * That function is the entry point for command line parsing and should be
- * called from the arch-specific code.
- */
-int __init parse_crashkernel(char *cmdline,
-			     unsigned long long system_ram,
-			     unsigned long long *crash_size,
-			     unsigned long long *crash_base)
+int __init parse_crashkernel_common(char *cmdline,
+				    unsigned long long system_ram,
+				    unsigned long long *crash_size,
+				    unsigned long long *crash_base)
 {
 	return __parse_crashkernel(cmdline, system_ram, crash_size, crash_base,
-					"crashkernel=", NULL);
+				   "crashkernel=", NULL);
 }
 
 int __init parse_crashkernel_high(char *cmdline,